#include "drive_24c02.h"


enum ENUM_TWI_REPLY
{
 TWI_NACK=0
 ,TWI_ACK=1
};

enum ENUM_TWI_BUS_STATE
 {
   TWI_READY=0
  ,TWI_BUS_BUSY=1
  ,TWI_BUS_ERROR=2
 };

void I2C_EE_Init(void)
 {
   GPIO_InitTypeDef  GPIO_InitStructure; 
   
   RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
   // Configure I2C1 pins: SCL and SDA 
   GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_12 | GPIO_Pin_13;
   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;  
   GPIO_Init(GPIOB, &GPIO_InitStructure);
   
 }


 void TWI_delay(void)
 { 
    uint8_t i=10; //i=10ʱ1.5us//Żٶ ͵5д
   while(i--); 
    
 }
 /**************************************************************************
ʱ
msʱĺ
CYCLECOUNTER / 72000000 
 ***************************************************************************/
 void DelayMs(uint16_t ms)
 {
         uint16_t iq0;
         uint16_t iq1;
  for(iq0 = ms; iq0 > 0; iq0--)
  {
   for(iq1 = 11998; iq1 > 0; iq1--); // ( (6*iq1+9)*iq0+15 ) / 72000000 
   
  }
 }

uint8_t TWI_Start(void)
 {
  SDAH;
  SCLH;
  TWI_delay();
  if(!SDAread)return TWI_BUS_BUSY; //SDAΪ͵ƽæ,˳
 SDAL;
  TWI_delay();
  if(SDAread) return TWI_BUS_ERROR; //SDAΪߵƽ߳,˳
 SCLL;
  TWI_delay();
  return TWI_READY;
 }

/*void TWI_Stop(void)
 {
  SCLL;
  TWI_delay();
  SDAL;
  TWI_delay();
  SCLH;
  TWI_delay();
  SDAH;
  TWI_delay();
 }*/
 void TWI_Stop(void)
 {
  SDAL;
  SCLL;
  TWI_delay();
  SCLH;
  TWI_delay();
  SDAH;
  TWI_delay();
 }

void TWI_Ack(void)
 { 
  SCLL;
  TWI_delay();
  SDAL;
  TWI_delay();
  SCLH;
  TWI_delay();
  SCLL;
  TWI_delay();
 }

void TWI_NoAck(void)
 { 
  SCLL;
  TWI_delay();
  SDAH;
  TWI_delay();
  SCLH;
  TWI_delay();
  SCLL;
  TWI_delay();
 }

uint8_t TWI_WaitAck(void)   //Ϊ:=1ACK,=0ACK
 {
  SCLL;
  TWI_delay();
  SDAH;   
  TWI_delay();
  SCLH;
  TWI_delay();
  if(SDAread)
  {
           SCLL;
           return 0;
  }
  SCLL;
  return 1;
 }

void TWI_SendByte(uint8_t SendByte) //ݴӸλλ//
 {
     uint8_t i=8;
     while(i--)
     {
         SCLL;
         TWI_delay();
         if(SendByte&0x80)
           SDAH;  
         else 
         SDAL;   
         SendByte<<=1;
         TWI_delay();
         SCLH;
         TWI_delay();
     }
     SCLL;
 }


 uint8_t TWI_ReceiveByte(void)  //ݴӸλλ//
 { 
     uint8_t i=8;
     uint8_t ReceiveByte=0;

    SDAH;    
     while(i--)
     {
       ReceiveByte <<= 1;      
       SCLL;
       TWI_delay();
       SCLH;
       TWI_delay(); 
       if(SDAread)
       {
         ReceiveByte |= 0x01;
       }
     }
     SCLL;
     return ReceiveByte;
 }

//أ3дɹ0дַ1æ2
//д1ֽ           SendByteд    WriteAddressдַ 
uint8_t TWI_WriteByte(uint8_t SendByte, uint8_t WriteAddress)
 {  
     uint8_t i;
     i = TWI_Start();
     if(i)
    return i;
      
    // TWI_SendByte( ADDR_24CXX & 0xFE);//дַ  д룺ַλ0ȡַλ1
     TWI_SendByte( ADDR_24CXX);
  if(!TWI_WaitAck())
  {
    TWI_Stop(); 
    return 0;
  }
  
     TWI_SendByte(WriteAddress);   //ʼַ      
     TWI_WaitAck(); 
     TWI_SendByte(SendByte);           //д
    TWI_WaitAck();   
     TWI_Stop(); 
  //ע⣺ΪҪȴEEPROMд꣬Բòѯʱʽ(10ms)
     DelayMs(12); //дʱ 12ms  дڴ10ms
    return 3;
 }

//أ0дַ1æ2,
 //1ֽ
//ReadAddressַ 
uint8_t TWI_ReadByte( uint8_t ReadAddress)
 {  
     uint8_t i,temp;
     i = TWI_Start();
     if(i)
    return i;
      
     TWI_SendByte(ADDR_24CXX);//дִַһαд 
    if(!TWI_WaitAck())
  {
    TWI_Stop(); 
    return 0;
  }

    TWI_SendByte(ReadAddress);   //ʼַ      
     TWI_WaitAck();
     TWI_Start();
     TWI_SendByte(ADDR_24CXX|0x01);    //ַ    д룺ַλ0ȡַλ1
     TWI_WaitAck();
    
     //*pDat = TWI_ReceiveByte();
     temp = TWI_ReceiveByte();
     
     TWI_NoAck();
      
     TWI_Stop();
     return temp;//ص012ͬˣٿһ
}

/***************************************************************************
24c256дֽ
psrc_dataָҪдָ
adr24c256Ҫдݵ׵ַ
nbyteдֽ
 ֵ:  0ִϣ1ִгִ
 βУC02ֻһַadrC256иλַhadr͵λַladr
 ***************************************************************************/
 uint8_t I2C_EE_BufferWrite(uint8_t *psrc_data,uint8_t adr,uint8_t nbyte)
 {
    uint8_t i;
   
  for(;nbyte!=0;nbyte--)
  {
   i = TWI_Start();
         if(i)
      return i;
          
         TWI_SendByte(ADDR_24CXX);//дַ 
    
      if(!TWI_WaitAck())
      {
        TWI_Stop(); 
        return 0;
      }
  
         TWI_SendByte(adr);   //ʼַ      
         TWI_WaitAck(); 
         TWI_SendByte(*psrc_data);           //д
        TWI_WaitAck();   
         psrc_data++;    //ָдݵָ1
   adr++;    //24C08Ĳַ1 
         TWI_Stop(); 
   //ע⣺ΪҪȴEEPROMд꣬Բòѯʱʽ(10ms)
         DelayMs(12); //дʱ 12ms  дڴ10ms
        
  }
  return 0;
 }


 /***************************************************************************
24c02ֽ
pdin_dataָҪݵָ
adr24c02Ҫݵ׵ַ
nbyteֽ
ֵ:  0ִϣ1ִгִ
***************************************************************************/
uint8_t I2C_EE_BufferRead(uint8_t *pdin_data,uint8_t adr,uint8_t nbyte)
 {
  uint8_t i;
     i = TWI_Start();
     if(i)
    return i;
      
     TWI_SendByte(ADDR_24CXX);//дִַһαд 
    if(!TWI_WaitAck())
  {
    TWI_Stop(); 
    return 0;
  }

 TWI_SendByte(adr);   //ʼַ      
     TWI_WaitAck();
     TWI_Start();
     TWI_SendByte(ADDR_24CXX|0x01);    //ַ    д룺ַλ0ȡַλ1
     TWI_WaitAck();

 while(nbyte!=1)                 //ǰ(nbyte-1)ֽ
 {
   *pdin_data = TWI_ReceiveByte(); //ѭ24C02жݣpdin_dataָĴ洢
  TWI_Ack();   //IICӦ
  pdin_data++;  //ָ洢ݵĴ洢ָ1
   nbyte--;  //ʣҪֽڼ1
  };

 *pdin_data = TWI_ReceiveByte();  //һֽ
 TWI_NoAck();      //IICӦ
     
     TWI_Stop();   
  
  return 0;
 }

/*
 void TWI_24CXX_Write(uint8_t* pDat, uint8_t nAddr, uint8_t nLen)
 {
   uint16_t i;
   for(i=0;i<nLen;i++)
   {
     TWI_WriteByte(*(pDat+i), nAddr+i);
     
    
   }
 }

void TWI_24CXX_Read(uint8_t* pDat, uint8_t nAddr, uint8_t nLen)
 {
     uint16_t i;
     for(i=0; i<nLen; i++)
       *(pDat+i) = TWI_ReadByte(nAddr+i);
 }
 */

